class Level {
  constructor({ image, layer }) {
    this.image = image;
    this.layer = layer;
  }
}

export default class LevelLoader {
  /**
   * Loads a level on memory from the specified source and layer.
   *
   * @return {Promise<Level>} A Promise that resolves with the loaded level.
   */
  static load({ source, layer }) {
    return new Promise((resolve, reject) => {
      const image = new Image();
      image.src = source;
      image.onload = () => resolve(new Level({ image, layer }));
      image.onerror = reject;
    });
  }
}
